package com.steerinfo.baseinfo.meterbaserailwaycarriageweight.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.user.UserPayload;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbaserailwaycarriageweight.model.MeterBaseRailwayCarriageWeight;
import com.steerinfo.baseinfo.meterbaserailwaycarriageweight.service.IMeterBaseRailwayCarriageWeightService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.*;
import java.math.BigDecimal;

/**
 * MeterBaseRailwayCarriageWeight RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-06-27 10:16
 * 类描述
 * 修订历史：
 * 日期：2022-06-27
 * 作者：generator
 * 参考：
 * 描述：MeterBaseRailwayCarriageWeight RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaserailwaycarriageweights")
public class MeterBaseRailwayCarriageWeightController extends BaseRESTfulController {

    @Autowired
    IMeterBaseRailwayCarriageWeightService meterBaseRailwayCarriageWeightService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwaycarriageweight:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayCarriageWeight> list = meterBaseRailwayCarriageWeightService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwaycarriageweight:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayCarriageWeight> list = meterBaseRailwayCarriageWeightService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseRailwayCarriageWeight对象创建")
    @ApiImplicitParam(name = "meterBaseRailwayCarriageWeight", value = "详细实体meterBaseRailwayCarriageWeight", required = true, dataType = "MeterBaseRailwayCarriageWeight")
    //@RequiresPermissions("meterbaserailwaycarriageweight:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseRailwayCarriageWeight model){
        //判断code是否唯一
        if (meterBaseRailwayCarriageWeightService.getByProperty("carriageCode",model.getCarriageCode()) != null){
            return failed(null,"存在相同Code");
        }

        model.setCarriageWeightNo(meterBaseRailwayCarriageWeightService.creatId());
        UserPayload payload = UserPayload.getCurrUser();
        model.setCreateManNo(payload.getUserCode());
        model.setCreateManName(payload.getUserName());
        model.setCreateTime(new Date());
        model.setValueFlag("1");
        MeterBaseRailwayCarriageWeight meterBaseRailwayCarriageWeight = meterBaseRailwayCarriageWeightService.add(model);
        return success(meterBaseRailwayCarriageWeight);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwaycarriageweight:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseRailwayCarriageWeight meterBaseRailwayCarriageWeight = meterBaseRailwayCarriageWeightService.getById(id);
        return success(meterBaseRailwayCarriageWeight);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseRailwayCarriageWeight信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseRailwayCarriageWeight", value = "详细实体meterBaseRailwayCarriageWeight", required = true, dataType = "MeterBaseRailwayCarriageWeight")
    })
    //@RequiresPermissions("meterbaserailwaycarriageweight:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseRailwayCarriageWeight model){
        model.setId(id);
        UserPayload payload = UserPayload.getCurrUser();
        model.setUpdateManNo(payload.getUserCode());
        model.setUpdateManName(payload.getUserName());
        model.setUpdateTime(new Date());
        MeterBaseRailwayCarriageWeight meterBaseRailwayCarriageWeight = meterBaseRailwayCarriageWeightService.modify(model);
        return success(meterBaseRailwayCarriageWeight);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwaycarriageweight:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseRailwayCarriageWeightService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="根据时间查询", notes="根据时间查询")
    //@RequiresPermissions("meterbaserailwaycarriageweight:delete")
    @GetMapping(value = "/queryByTime")//String
    public RESTfulResult queryByTime(@RequestParam HashMap<String,Object> map,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRailwayCarriageWeight> list = meterBaseRailwayCarriageWeightService.queryByTimeForPage(map,pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="查询")
    //@RequiresPermissions("meterbaserailwaycarriageweight:delete")
    @GetMapping(value = "/queryList")
    public RESTfulResult queryList(@RequestParam HashMap<String,Object> map){
        List<MeterBaseRailwayCarriageWeight> list = meterBaseRailwayCarriageWeightService.queryList(map);
        return success(list);
    }

    @ApiOperation(value="逻辑删除", notes="逻辑删除")
    //@RequiresPermissions("meterbaserailwaycarriageweight:delete")
    @PutMapping(value = "/deleteByLogic")//String
    public RESTfulResult deleteByLogic(@RequestParam String id){
        //判断主键是否存在
        MeterBaseRailwayCarriageWeight meterBaseRailwayCarriageWeight = meterBaseRailwayCarriageWeightService.queryById(id);
        if (meterBaseRailwayCarriageWeight == null){
            return failed(null,"找不到主键对应的值");
        }
        meterBaseRailwayCarriageWeight.setValueFlag("0");
        meterBaseRailwayCarriageWeightService.deleteByLogic(meterBaseRailwayCarriageWeight);
        return success(null,"删除成功");
    }

}
